unit TapiH;

interface

   uses Windows,Messages;
   
type
   LPHCall = ^THCall;
   THCall = Longint;

   LPHLine = ^THLine;
   THLine = Longint;

   LPHLineApp = ^THLineApp;
   THLineApp = Longint;

LPLineDialParams = ^TLineDialParams;
  TLineDialParams = record
    dwDialPause,
    dwDialSpeed,
    dwDigitDuration,
    dwWaitForDialtone: Longint;
    end;

  LPLineCallParams = ^TLineCallParams;
  TLineCallParams = record              { Defaults: }
    dwTotalSize,                        { --------- }

    dwBearerMode,                       { voice }
    dwMinRate,                          { (3.1kHz) }
    dwMaxRate,                          { (3.1kHz) }
    dwMediaMode,                        { interactiveVoice }

    dwCallParamFlags,                   { 0 }
    dwAddressMode,                      { addressID }
    dwAddressID: Longint;               { (any available) }

    DialParams: TLineDialParams;        { (0, 0, 0, 0) }

    dwOrigAddressSize,                  { 0 }
    dwOrigAddressOffset,
    dwDisplayableAddressSize,
    dwDisplayableAddressOffset,

    dwCalledPartySize,                  { 0 }
    dwCalledPartyOffset,

    dwCommentSize,                      { 0 }
    dwCommentOffset,

    dwUserUserInfoSize,                 { 0 }
    dwUserUserInfoOffset,

    dwHighLevelCompSize,                { 0 }
    dwHighLevelCompOffset,

    dwLowLevelCompSize,                 { 0 }
    dwLowLevelCompOffset,

    dwDevSpecificSize,                  { 0 }
    dwDevSpecificOffset: Longint;
    end;

  LPLineCallInfo = ^TLineCallInfo;
  TLineCallInfo = record
    dwTotalSize,
    dwNeededSize,
    dwUsedSize: Longint;

    hLine: THLine;
    dwLineDeviceID,
    dwAddressID,

    dwBearerMode,
    dwRate,
    dwMediaMode,

    dwAppSpecific,
    dwCallID,
    dwRelatedCallID,
    dwCallParamFlags,
    dwCallStates,

    dwMonitorDigitModes,
    dwMonitorMediaModes: Longint;
    DialParams: TLineDialParams;

    dwOrigin,
    dwReason,
    dwCompletionID,
    dwNumOwners,
    dwNumMonitors,

    dwCountryCode,
    dwTrunk,

    dwCallerIDFlags,
    dwCallerIDSize,
    dwCallerIDOffset,
    dwCallerIDNameSize,
    dwCallerIDNameOffset,

    dwCalledIDFlags,
    dwCalledIDSize,
    dwCalledIDOffset,
    dwCalledIDNameSize,
    dwCalledIDNameOffset,

    dwConnectedIDFlags,
    dwConnectedIDSize,
    dwConnectedIDOffset,
    dwConnectedIDNameSize,
    dwConnectedIDNameOffset,

    dwRedirectionIDFlags,
    dwRedirectionIDSize,
    dwRedirectionIDOffset,
    dwRedirectionIDNameSize,
    dwRedirectionIDNameOffset,

    dwRedirectingIDFlags,
    dwRedirectingIDSize,
    dwRedirectingIDOffset,
    dwRedirectingIDNameSize,
    dwRedirectingIDNameOffset,

    dwAppNameSize,
    dwAppNameOffset,

    dwDisplayableAddressSize,
    dwDisplayableAddressOffset,

    dwCalledPartySize,
    dwCalledPartyOffset,

    dwCommentSize,
    dwCommentOffset,

    dwDisplaySize,
    dwDisplayOffset,

    dwUserUserInfoSize,
    dwUserUserInfoOffset,

    dwHighLevelCompSize,
    dwHighLevelCompOffset,

    dwLowLevelCompSize,
    dwLowLevelCompOffset,

    dwChargingInfoSize,
    dwChargingInfoOffset,

    dwTerminalModesSize,
    dwTerminalModesOffset,

    dwDevSpecificSize,
    dwDevSpecificOffset: Longint;
  end;

  LPLineExtensionID = ^TLineExtensionID;
  TLineExtensionID = record
    dwExtensionID0,
    dwExtensionID1,
    dwExtensionID2,
    dwExtensionID3: Longint;
  end;


{ Messages for Phones and Lines }

const

  LINEMAPPER = $FFFFFFFF;

  LINE_ADDRESSSTATE       = 0;
  LINE_CALLINFO           = 1;
  LINE_CALLSTATE          = 2;
  LINE_CLOSE              = 3;
  LINE_DEVSPECIFIC        = 4;
  LINE_DEVSPECIFICFEATURE = 5;
  LINE_GATHERDIGITS       = 6;
  LINE_GENERATE           = 7;
  LINE_LINEDEVSTATE       = 8;
  LINE_MONITORDIGITS      = 9;
  LINE_MONITORMEDIA       = 10;
  LINE_MONITORTONE        = 11;
  LINE_REPLY              = 12;
  LINE_REQUEST            = 13;
  PHONE_BUTTON            = 14;
  PHONE_CLOSE             = 15;
  PHONE_DEVSPECIFIC       = 16;
  PHONE_REPLY             = 17;
  PHONE_STATE             = 18;
  LINE_CREATE             = 19;
  PHONE_CREATE            = 20;


  LINECALLSTATE_IDLE                = $00000001;
  LINECALLSTATE_OFFERING            = $00000002;
  LINECALLSTATE_ACCEPTED            = $00000004;
  LINECALLSTATE_DIALTONE            = $00000008;
  LINECALLSTATE_DIALING             = $00000010;
  LINECALLSTATE_RINGBACK            = $00000020;
  LINECALLSTATE_BUSY                = $00000040;
  LINECALLSTATE_SPECIALINFO         = $00000080;
  LINECALLSTATE_CONNECTED           = $00000100;
  LINECALLSTATE_PROCEEDING          = $00000200;
  LINECALLSTATE_ONHOLD              = $00000400;
  LINECALLSTATE_CONFERENCED         = $00000800;
  LINECALLSTATE_ONHOLDPENDCONF      = $00001000;
  LINECALLSTATE_ONHOLDPENDTRANSFER  = $00002000;
  LINECALLSTATE_DISCONNECTED        = $00004000;
  LINECALLSTATE_UNKNOWN             = $00008000;

  LINEDISCONNECTMODE_NORMAL       = $00000001;
  LINEDISCONNECTMODE_UNKNOWN      = $00000002;
  LINEDISCONNECTMODE_REJECT       = $00000004;
  LINEDISCONNECTMODE_PICKUP       = $00000008;
  LINEDISCONNECTMODE_FORWARDED    = $00000010;
  LINEDISCONNECTMODE_BUSY         = $00000020;
  LINEDISCONNECTMODE_NOANSWER     = $00000040;
  LINEDISCONNECTMODE_BADADDRESS   = $00000080;
  LINEDISCONNECTMODE_UNREACHABLE  = $00000100;
  LINEDISCONNECTMODE_CONGESTION   = $00000200;
  LINEDISCONNECTMODE_INCOMPATIBLE = $00000400;
  LINEDISCONNECTMODE_UNAVAIL      = $00000800;
  LINEDISCONNECTMODE_NODIALTONE   = $00001000;

  LINEBEARERMODE_VOICE            = $00000001;
  LINEBEARERMODE_SPEECH           = $00000002;
  LINEBEARERMODE_MULTIUSE         = $00000004;
  LINEBEARERMODE_DATA             = $00000008;
  LINEBEARERMODE_ALTSPEECHDATA    = $00000010;
  LINEBEARERMODE_NONCALLSIGNALING = $00000020;
  LINEBEARERMODE_PASSTHROUGH      = $00000040;

  LINEMEDIAMODE_UNKNOWN           = $00000002;
  LINEMEDIAMODE_INTERACTIVEVOICE  = $00000004;
  LINEMEDIAMODE_AUTOMATEDVOICE    = $00000008;
  LINEMEDIAMODE_DATAMODEM         = $00000010;
  LINEMEDIAMODE_G3FAX             = $00000020;
  LINEMEDIAMODE_TDD               = $00000040;
  LINEMEDIAMODE_G4FAX             = $00000080;
  LINEMEDIAMODE_DIGITALDATA       = $00000100;
  LINEMEDIAMODE_TELETEX           = $00000200;
  LINEMEDIAMODE_VIDEOTEX          = $00000400;
  LINEMEDIAMODE_TELEX             = $00000800;
  LINEMEDIAMODE_MIXED             = $00001000;
  LINEMEDIAMODE_ADSI              = $00002000;
  LINEMEDIAMODE_VOICEVIEW         = $00004000;

  LINECALLPRIVILEGE_NONE        = $00000001;
  LINECALLPRIVILEGE_MONITOR     = $00000002;
  LINECALLPRIVILEGE_OWNER       = $00000004;

  function lineDeallocateCall(
    hCall: THCall): Longint; stdcall;

  function lineGetCallInfo(
    hCall: THCall;
    var lpCallInfo: TLineCallInfo): Longint; stdcall;


  function lineInitialize(
    var lphLineApp: THLineApp;
    hInstance: THandle;
    lpfnCallback: Pointer;
    lpszAppName: PChar;
    var lpdwNumDevs: Longint): Longint; stdcall;


  function lineShutdown(
    hLineApp: THLineApp): Longint; stdcall;

  function lineNegotiateAPIVersion(
    hLineApp: THLineApp;
    dwDeviceID, dwAPILowVersion, dwAPIHighVersion: Longint;
    var lpdwAPIVersion: Longint;
    var lpExtensionID: TLineExtensionID): Longint; stdcall;

  function lineOpen(
    hLineApp: THLineApp;
    dwDeviceID: Longint;
    var lphLine: THLine;
    dwAPIVersion, dwExtVersion, dwCallbackInstance,
    dwPrivileges, dwMediaModes: Longint;
    var lpCallParams: TLineCallParams): Longint; stdcall;

  function lineClose(
    hLine: THLine): Longint; stdcall;

  function lineMakeCall(
    hLine: THLine;
    var lphCall: THCall;
    lpszDestAddress: Pchar;
    dwCountryCode: Longint;
    var lpCallParams: TLineCallparams): Longint; stdcall;


  function lineDrop(
    hCall: THCall;
    lpsUserUserInfo: PChar;
    dwSize: Longint): Longint; stdcall;

implementation


function lineDeallocateCall           ; external 'Tapi32.dll' index 12;
function lineGetCallInfo              ; external 'Tapi32.dll' index 25;
function lineInitialize               ; external 'Tapi32.dll' index 42;
function lineShutdown                 ; external 'Tapi32.dll' index 74;
function lineNegotiateAPIVersion      ; external 'Tapi32.dll' index 47;
function lineOpen                     ; external 'Tapi32.dll' index 49;
function lineClose                    ; external 'Tapi32.dll' index 6;
function lineMakeCall                 ; external 'Tapi32.dll' index 43;
function lineDrop                     ; external 'Tapi32.dll' index 16;


end.
